#include <stdlib.h>
#include <stdio.h>
#include <gp.h>

#define MIN(a,b) ((a) < (b) ? (a) : (b))
#define ABS(a) ((a) > 0. ? (a) : (-(a)))

float minflt_(void);

int main() 
{
  int a,andrew;
  float b,david;
  int debug=1;
  int x,y,z;
  double c,john,themin;
#include "parinclude.c"

  themin = (double) minflt_();
  debug=DEBUG;

  printf( "_____________________________________________________\n");
  printf( "\n");
  printf( "           Testing        C        functions         \n");
  printf( "_____________________________________________________\n");
  x = ifetch("andrew",&a);
  y = ffetch("david",&b);
  z = dfetch("john",&c);

      if(debug == 1) 
	{
	  printf("themin = %e\n",themin);
	  printf("int andrew = %-14d  read = %-14d err = %d\n",andrew,a,x);
	  printf("int david  = %-14e  read = %-14e err = %d\n",david,b,y);
	  printf("int john   = %-14e  read = %-14e err = %d\n",john,c,z);
	}
      if(andrew != a ||  ABS(david-b) > themin || ABS(john-c) > themin || (x*y*z) == 0)
         {
	   exit(1);
	 }

      printf( "_____________________________________________________\n");
      printf( " \n");
      printf( "           Testing C GP_xxxx       functions         \n");
      printf( "_____________________________________________________\n");

      a = GP_ifetch("andrew",0,"DEFAULT");
      b = GP_ffetch("david",345.,"DEFAULT");
      c = GP_dfetch("john",0.e0,"DEFAULT");
      
      if(debug == 1) 
	{
	  printf("themin = %e\n",themin);
	  printf("int andrew = %-14d  read = %-14d err = %d\n",andrew,a,x);
	  printf("int david  = %-14e  read = %-14e err = %d\n",david,b,y);
	  printf("int john   = %-14e  read = %-14e err = %d\n",john,c,z);
	}
      if(andrew != a ||  ABS(david-b) > themin || ABS(john-c) > themin || (x*y*z) == 0)
         {
	   exit(1);
	 }
      if(debug == 2) {
         a = GP_ifetch("andrew",0,"WARNING");
         b = GP_ffetch("david",0.,"WARNING");
         c = GP_dfetch("john",0.e0,"WARNING");

         a = GP_ifetch("noandrew",0,"WARNING");
         b = GP_ffetch("nodavid",345.,"WARNING");
         c = GP_dfetch("nojohn",0.e0,"WARNING");

         a = GP_ifetch("andrew",0,"SEVERE");
         b = GP_ffetch("david",0.,"SEVERE");
         c = GP_dfetch("john",0.e0,"SEVERE");

         a = GP_ifetch("noandrew",0,"SEVERE");
         b = GP_ffetch("nodavid",0.,"SEVERE");
         c = GP_dfetch("nojohn",0.e0,"SEVERE");}
      exit(0);
}
